﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
public class TargetSpawner : MonoBehaviour
{
    public GameObject targetPrefab;
    public GameObject targetSpawnPoint;

    [Header("Game Options")]
    public int maxBooger = 3;

    // Start is called before the first frame update
    void Start()
    {
        InvokeRepeating("SpawnPreciousOne", 1f, 1f);  //1s delay, repeat every 1s
    }

    // Update is called once per frame
    void SpawnPreciousOne()
    {
        Image[] boogers = targetSpawnPoint.GetComponentsInChildren<Image>();
        if ((boogers == null) || (boogers.Length < maxBooger))
        {
            GameObject booger = Instantiate(targetPrefab, targetSpawnPoint.transform);

            float pointX;
            int retry = 0;
            do
            {
                retry++;
                pointX = Random.Range(-0.7f, 0.7f) * 100f + targetSpawnPoint.transform.position.x;
            } while (HasBooger(pointX, false) && retry < 3);

            booger.GetComponent<RectTransform>().position = new Vector3(
                pointX,
                booger.transform.position.y,
                booger.transform.position.z
            );
        }
    }

    public bool HasBooger(float pointX, bool destory)
    {
        bool found = false;
        foreach ( Image booger in targetSpawnPoint.GetComponentsInChildren<Image>()){
            if ( Mathf.Abs(booger.rectTransform.position.x - pointX) < 30f) {
                found = true;
                if (destory)
                {
                    Destroy(booger);
                }
                break;
            }
        }
        return found;
    }
}
