﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class GameManager : MonoBehaviour
{
    // GameOverUI
    public GameObject gameOverUI;

    public SceneController sceneController;
    public int precious = 0;
    public int currentSceneNumber = 1;

    public GameObject preciousPref;

    [Header("Difficulty")]
    public int startHealth = 3;
    public int treasureStackCnt = 1;
    private int treasureNextIdx = 0;
    public int zoomOutCount = 10;
    public int endSceneCount = 100;

    public float bangAppearTime = 3f;
    public float wifeAppearTime = 1f;

    public ArmAnimator armAnimator;

    public GameObject treasureArr;
    SpriteRenderer[] treasures;

    [Header("Bang")]
    public Image bang;
    public Image wife;

    bool reserved = false;
    bool wifeIsHere = false;

    bool end = false;

    bool isPressed = false;

    public GameObject ButtonUp;
    public GameObject ButtonDown;

    public GaugeMovement gaugeMovement;

    public GameObject preciousAnimePref;

    public GameObject preciousParent;

    private void Awake()
    {
        treasures = treasureArr.GetComponentsInChildren<SpriteRenderer>();
    }

    void Start()
    {
        Peaceful();

    }

    // Update is called once per frame
    void Update()
    {
        if(Input.GetKeyDown("a") && !end) {
            Pressed();
        }

        if (isPressed && !end)
        {
            if (wifeIsHere)
            {
                Damaged();

                return;
            }
            if (Input.GetKeyUp("a") && !end)
            {
                Shoot();
            }
        }
        if (precious > endSceneCount)
        {
            end = true;
            sceneController.Select("PlayScene" + (currentSceneNumber + 1));
        }
    }

    public void Pressed()
    {
        isPressed = true;
        armAnimator.MoveArm();
        ButtonUp.SetActive(false);
        ButtonDown.SetActive(true);
        gaugeMovement.MoveGauge();
        //gaugeMovement.ResetPosition();

    }

    private void Shoot()
    {

        if (true)// gaugeMovement.IsHit())
        {
            armAnimator.RotateArm();
            ButtonUp.SetActive(true);
            ButtonDown.SetActive(false);
            isPressed = false;
            gaugeMovement.PauseGauge();
            GameObject generatedPreciousAnime = Instantiate(preciousAnimePref, preciousParent.transform);
            //GameObject generatedPrecious = Instantiate(preciousPref);
            //generatedPrecious.transform.localScale = new Vector3(Random.Range(0.1f, 0.3f), Random.Range(0.1f, 0.3f), Random.Range(0.1f, 0.3f));
            precious++;

            if (precious / treasureStackCnt >= treasureNextIdx + 1)
            {
                treasures[treasureNextIdx].enabled = true;
                treasureNextIdx++;
            }
            StartCoroutine(RemoveObj(generatedPreciousAnime));
        }
        else
        {
            unPressed();
        }
        ButtonUp.SetActive(true);
        ButtonDown.SetActive(false);
    }

    IEnumerator RemoveObj(GameObject obj)
    {
        float t = 0f;
        while (t < 1f)
        {
            t += Time.deltaTime;
            yield return 0;
        }
        Destroy(obj);
    }
    private void unPressed()
    {
        ButtonUp.SetActive(true);
        ButtonDown.SetActive(false);
        isPressed = false;
        gaugeMovement.PauseGauge();
        armAnimator.DoNothing();
    }
    private void Damaged()
    {
        Debug.Log("DAMAGED!!!");
        StartCoroutine(PauseGame(3f));
        unPressed();

        if (startHealth <= 0)
        {
            GameOver();
            return;
        }
        startHealth--;
    }

    public IEnumerator PauseGame(float wait)
    {
        Debug.Log("Inside PauseGame()");
        GameObject[] childParticles = preciousParent.GetComponentsInChildren<GameObject>();

        foreach (GameObject childParticle in childParticles)
        {
            childParticle.GetComponent<Animator>().enabled = false;
        }

        yield return new WaitForSeconds(wait);
    }


    private void GameOver()
    {
        Debug.Log("GameOver");
        gameOverUI.SetActive(true);
    }

    private void WifeHi()
    {
        Debug.Log("WifeHi");
        if (!reserved)
        {
            reserved = true;
            StartCoroutine(Coming(bangAppearTime));
        }
    }

    private void WifeBye()
    {
        Debug.Log("WifeBye");
        StartCoroutine(Gone(wifeAppearTime));
    }

    private void Peaceful()
    {
        Debug.Log("Peaceful");
        float wait = Random.Range(0.3f, 2f);
        // public SpauseController spauseController;
        //TO-DO MJ : spauseController.Walk();
        // in spouseController.cs
        // wifeLeftObj, wifeRightObj, wifeBackObj, wifeFrontObj
        // -> public void Walk(){
        // wifeLeftObj.setActive(true);
        // wifeLeftObj.getComponent<Animator>().enabled = true;
        StartCoroutine(Rest(wait));
    }

    IEnumerator Coming(float wait)
    {
        float t = 0f;

        bang.enabled = true;
        while (t < wait)
        {
            t += Time.deltaTime;
            yield return 0;
        }

        wife.enabled = true;
        wifeIsHere = true;
        WifeBye();
    }

    IEnumerator Gone(float wait)
    {
        float t = 0f;

        while (t < wait)
        {
            t += Time.deltaTime;
            yield return 0;
        }

        wife.enabled = false;
        bang.enabled = false;
        wifeIsHere = false;
        reserved = false;
        Peaceful();
    }

    IEnumerator Rest(float wait)
    {
        float t = 0f;

        while (t < wait)
        {
            t += Time.deltaTime;
            yield return 0;
        }

        WifeHi();
    }
}
